/* Copyright (c) 1996 University of Utah.  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for NON-COMMERCIAL purposes and without fee is
 * hereby granted provided that this copyright notice appears in all
 * copies.
 *
 * See http://www.cs.utah.edu/~hamlet for more educational resources.
 *
 * The University of Utah MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT
 * THE SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. The University of Utah SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/* Written by Elizabeth S. Odekirk */

package Rational;

/*import hamlet.*;*/
import java.awt.*;
import java.util.*;
import java.applet.Applet;
import java.io.*;


public class Eqn extends Panel {

  String foo;
  String outStr;
  StreamTokenizer st;
  String sval;
  TextField eqnField = new TextField("1 + 1                                 ");
  TextField statusField = new TextField("                                   ");
  Panel eqnPanel     = new Panel();
  Panel statusPanel  = new Panel();
  /*final int PLUS = '+';
  final int MINUS = '-';*/
  Rational parent;
  /*Object parent;*/
  int mantVal = 1, minExpVal = -1, maxExpVal = 1;
  int maxInt = 10,
      minInt = -10;
  RdsFrame rdsFrame = new RdsFrame();
  /*TextField maxintField = new TextField("10");
  TextField minintField = new TextField("-10");*/
  
  double maxx = 0;
  double minx = 0;

  public Eqn(Rational parentIn) {
    /* The expression line */
    eqnPanel.setLayout(new BorderLayout());
    /*    eqnPanel.add("North", minintField);
    eqnPanel.add("South", maxintField);*/
    eqnPanel.add("West", new Label("Expression Input "));
    eqnPanel.add("Center", eqnField);   
    /* The status line */
    statusField.setEditable(false);
    statusPanel.setLayout(new BorderLayout());
    statusPanel.add("West", new Label("Expression Status"));
    statusPanel.add("Center", statusField);
    /* The whole component */
    setLayout(new BorderLayout());
    add("North", eqnPanel);
    add("South", statusPanel);
    /*parent = (Rational) parentIn;*/
    parent = parentIn;

  } /* end init() */  

  public boolean handleEvent( Event e ) {
    int eqidx;
    String exptxt;

    if (e.target == eqnField) {
      if (e.id == Event.ACTION_EVENT)  {
	parseIt();
	return true;
      }
      if (e.id == Event.KEY_PRESS) {
	int start, end;
	exptxt = eqnField.getText();
	eqidx = exptxt.indexOf('=');
	if (eqidx >= 0) {
	  start = eqnField.getSelectionStart();
	  end = eqnField.getSelectionEnd();
	  exptxt = exptxt.substring(0, eqidx);
	  eqnField.setText(exptxt);
	  eqnField.select(start, end);
	  return false;
	}
	return false;
      }
    }
    return false;
  } /* end handleEvent() */


  public void reset (String s) {
    statusField.setText(s);
    eqnField.setText("");
  }

  public void parseIt() {
    RaVal val = new RaVal(this);
    String streq;
    String strval;
    int token = 0;
    int eqidx = 0;
    
    foo = eqnField.getText();
    eqidx = foo.indexOf('=');
    if (eqidx >= 0)
      foo = foo.substring(0, eqidx);
    /*System.out.println("The initial string is: " + foo);*/
    st = new StreamTokenizer(new StringBufferInputStream(foo));
    st.ordinaryChar('/');  
    st.ordinaryChar('-');  
    maxInt = parent.sharedInfo.maxInt;
    minInt = parent.sharedInfo.minInt;
    /* System.out.println("Min int is: " + minintField.getText());
    System.out.println("Max int is: " + maxintField.getText());
    minInt = new Integer((minintField.getText())).intValue();
    maxInt = new Integer((maxintField.getText())).intValue();*/
    /*    mantVal = parent.mantSize.getIntText();
    maxExpVal = parent.maxExp.getIntText();
    minExpVal = parent.minExp.getIntText();*/
    minx = Math.pow(10, minExpVal);
    maxx = Math.pow(10, maxExpVal+1) * (1 - Math.pow(10, -(mantVal)));
    statusField.setText("");
    if (parent.sharedInfo.halted == true) {
      statusField.setText("No number system set");
      return;
    }
    try {
      val = exp();
      token = st.nextToken();
      if (token != StreamTokenizer.TT_EOF) 
	throw new SyntaxException("extra tokens");
    } catch (IOException ex) {}
      catch (SyntaxException e) {
	statusField.setText("Syntax Error - " + e.getMessage());
	eqnField.setText(foo.trim());
	return;
      }
      catch (ComputationException e) {
	statusField.setText("Computation Error - " + e.getMessage());
	eqnField.setText(foo.trim());
	return;
      }
    /*System.out.println("Value is: " + val.toString());*/
    outStr = foo.trim();
    outStr = outStr.concat(" = ");
    outStr = outStr.concat(val.toString());
    eqnField.setText(outStr);
    statusField.setText("Successfully Completed");
  }
  
  /* + and - */
  RaVal exp() throws SyntaxException, ComputationException {
    RaVal val = new RaVal(this);
    int token = 0;

    val = term();
    while (true) {
      try {
	token = st.nextToken();
      } catch (IOException ex) {}
      if (token == '+' ) {
	val.add(term());
	val.check();
      }
      else if (token == '-' ) {
	val.subtr(term());
	val.check();
      }
      else {
	st.pushBack();
	return val;
      }
    }
  } /* end exp */

  /* Executing * and / */
  RaVal term() throws SyntaxException, ComputationException {
    RaVal val = new RaVal(this);
    int token = 0;

    val = foo();
    while (true) {
      try {
	token = st.nextToken();
      } catch (IOException ex) {}
      if (token == '*') {
	val.mult(foo());
	val.check();
      }
      else if (token == '/') {
	val.div(foo());
	val.check();
      }
      else {
	st.pushBack();
	return val;
      }
    }
  } /* end term */

  /* Executing unary -  and + */
  RaVal foo() throws SyntaxException, ComputationException {
    RaVal val = new RaVal(this);
    boolean gotUnaryMinus = false;
    int token = 0;

    try {
      token = st.nextToken();
    } catch (IOException ex) {}
    if (token == '-') 
      gotUnaryMinus = true;
    else if (token == '+')
      ;
    else 
      st.pushBack();
    val = pt();
    if (gotUnaryMinus) {
      val.negate();
      val.check();
    }
    return val;
  } /* end foo */

  /* Executing ^ */
  RaVal pt()  throws SyntaxException, ComputationException {
    RaVal val = new RaVal(this);
    int token = 0;
    val = f();

    try {
      token = st.nextToken();
    } catch (IOException ex) {}
    if (token == '^') {
      val.expon(f());
      val.check();
    }
    else 
      st.pushBack();
    return val;
  } /* end pt */

  /* Executing ( and ) and number */
  RaVal f() throws SyntaxException, ComputationException {
    RaVal val = new RaVal(this);
    int token = 0;
    
    try {
      token = st.nextToken();
    } catch (IOException ex) {}
    if (token == '(') {
      val = exp();
      try {
	token = st.nextToken();
      } catch (IOException ex) {}
      if (token != ')') 
	throw new SyntaxException("no )");
    }
    else if (st.ttype == StreamTokenizer.TT_NUMBER) {
      val.set(st.nval);
      val.checkInput();
    }
    else {
      throw new SyntaxException("number expected");
    }
    return val;
  } /* end f */
}

class RdsFrame extends Frame {
  TextArea rds = new TextArea(200, 200); 

  public Dimension preferredSize() {
    return new Dimension(220,220);
  }

  public RdsFrame (){
    add ("Center", rds);
    pack();
    /*show();*/
  }
}


class ComputationException extends Exception {

  public ComputationException(String s) {
    super(s);
  }
}

class SyntaxException extends Exception {

  public SyntaxException(String s) {
    super(s);
  }
}

interface Val {

  String toString();
  void    add(Val valTwo); 
  void    set(double d) throws ComputationException;
  void    check();
}


class RaVal {
  int num;
  int denom;
  Eqn parent;

  public RaVal(Eqn eqn) {
    num   = 0;
    denom = 0;
    parent = eqn;
  }

  public RaVal(int inNum, int inDenom, Eqn eqn) {
    num   = inNum;
    denom = inDenom;
    parent = eqn;
  }

  public String toString() {
    String str;
    if (denom == 1)
      str = new String("" + num );
    else
      str = new String(num + "/" + denom);
    return str;
  }

  /* a/b + c/d = (ad + cb)/bd */
  public void add(RaVal valTwo) {
    num = (num * valTwo.denom + valTwo.num * denom);
    denom = denom * valTwo.denom;
    reduce();
  }
  
  /* a/b - c/d = (ad - cb)/bd */
  public void subtr(RaVal valTwo) {
    num = (num * valTwo.denom - valTwo.num * denom);
    denom = denom * valTwo.denom;
    reduce();
  }

  /* (a/b) * (c/d) = ac/bd */
  public void mult(RaVal valTwo) {
    num = num * valTwo.num;
    denom = denom * valTwo.denom;
    reduce();
  }

  /* (a/b) / (c/d) = ad/bc */
  public void div(RaVal valTwo) {
    num = num * valTwo.denom;
    denom = denom * valTwo.num;
    reduce();
  }

  /* -(a/b) = (-a)/b */
  public void negate() {
    num = -num;
  }

  public void set(double d) throws SyntaxException {
    double checkForInt = Math.floor(d);

    /* If it's not an integer, then it's a syntax error */
    if ( (checkForInt - d) != 0)  
      throw new SyntaxException(d + " is not an integer");
    num = new Double(d).intValue();
    denom = 1;
  }


  /* (a/b)^(c/d) = a^(c/d) / b^(c/d) 
   *   For right now, don't allow d to be anything but 1 
   *   If c is negative, need to swap num and denom of a/b */
  public void expon(RaVal valTwo) throws ComputationException {
    double floatValTwo = valTwo.num / valTwo.denom;
    if (valTwo.denom != 1)
      throw new ComputationException("exponent must be an integer");
    if (valTwo.denom < 0 ) {
      int temp;
      temp = num;
      num = denom;
      denom = temp;
    }
    try {
      num = (int) Math.pow(num, floatValTwo);
      denom = (int) Math.pow(denom, floatValTwo);
    } catch (ArithmeticException e) {
//        System.out.println(e.getMessage());
      }
  }

  /* Reduce the fraction. */
  void reduce() {
    int curgcd;
    curgcd = GCD.gcd(num, denom);
    if (num != 0) {
      num = num / curgcd;
      denom = denom / curgcd;
    }
    if (num <= 0 && denom < 0) {
      num = -num;
      denom = -denom;
    }
    if (num > 0 && denom < 0) {
      num = -num;
      denom = -denom;
    }
  } /* End reduce */

  public void check() throws ComputationException, SyntaxException {
    insideCheck(false);
  }

  public void checkInput() throws ComputationException, SyntaxException {
    insideCheck(true);
  }

  /* Check to see that the number is in our number system.
   * To do this, I need to check to see if both num and
   * denom are in between maxInt and minInt.  Also need to
   * look at negatives - do this later. */
  public void insideCheck(boolean isInput) 
                    throws ComputationException, SyntaxException {
    boolean fail = false;
    
    /*System.out.println("Checking " + num + "/" + denom);*/
    if (num > parent.maxInt || num < parent.minInt) {
      fail = true;
    }
    else if (denom > parent.maxInt || denom < parent.minInt) {
      fail = true;
    }
    /* Now, check that it's not just a neg num thing.  
       If it's positive, try turning both num and denom to 
         negative and see if it works.  
       If it's negative, try switching the place of the negative
         from num to denom or visa versa.
    */	 
    int tempNum, tempDenom;
    if (fail) {
      tempNum = -num;
      tempDenom = -denom;
      if (tempNum > parent.maxInt || tempNum < parent.minInt) 
	fail = true;
      else if (tempDenom > parent.maxInt || tempDenom < parent.minInt) 
	fail = true;
      else
	fail = false;
    }
	
    if (fail)
      if (isInput)
	throw new SyntaxException (toString() + " out of bounds");
      else
	throw new ComputationException (toString() + " out of bounds");
    
  } /* end check */

}


